Subject: Re: [PATCH] fast-import: Fix crash when referencing already existing objects

From: "Shawn O. Pearce" <[email-masked]>
Date: Wed, 23 May 2007 23:44:15 -0400

Simon Hausmann <[email-masked]> wrote:
> Commit a5c1780a0355a71b9fb70f1f1977ce726ee5b8d8 sets the pack_id of existing
> objects to MAX_PACK_ID. When the same object is referenced later again it is
> found in the local object hash. With such a pack_id fast-import should not try
> to locate that object in the newly created pack(s).

Thanks, that was a _really_ nasty bug.  :-(

Turns out there's more cases.  Such as if we reload a mark table of
commits (--import-marks) and then try to create a branch from them.
The existing commit will also have a pack_id of MAX_PACK_ID and
we'll go right into the same corruption you saw and fixed here.

I will be pushing your two patches and my additional fixup to
my maint branch tonight.

-- 
Shawn.